Name:           vsftpd
Version:        3.0.2
Release:        2%{?dist}
Summary:        Very Secure Ftp Daemon

Group:          System Environment/Daemons
License:        GPLv2 with exceptions
URL:            http://vsftpd.devnet.ru
Source0:        http://vsftpd.devnet.ru/files/%{version}/ext.1/vsFTPd-%{version}-ext1.tgz
Source1:        vsftpd.xinetd
Source2:        vsftpd.pam
Source3:        vsftpd.ftpusers
Source4:        vsftpd.user_list
Source5:        vsftpd.init
Source6:        vsftpd_conf_migrate.sh
# Ext 1 files
Source7:        vsftpd-403.html
Source8:        vsftpd-404.html
Source9:        vsftpd-browse.html
Source10:       vsftpd-browse_line.html
Source11:       vsftpd-403-serv.html
Source12:       vsftpd-site.conf
Source13:       vsftpd.pasv_rules

Patch0:         vsFTPd-2.3.4-ext.1-config.patch
Patch1:         vsFTPd-3.0.2-ext.1-define.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: pam-devel
BuildRequires: libcap-devel
BuildRequires: openssl-devel
BuildRequires: tcp_wrappers-devel
Requires: logrotate
Requires (preun): /sbin/chkconfig
Requires (preun): /sbin/service
Requires (post): /sbin/chkconfig


%description
vsftpd is a Very Secure FTP daemon. It was written completely from
scratch.


%prep
%setup -q -n vsFTPd-%{version}-ext.1
cp %{SOURCE1} .
%patch0 -p1 -b .conf
%patch1 -p1 -b .define

%build
%ifarch s390x sparcv9 sparc64
make CFLAGS="$RPM_OPT_FLAGS -fPIE -pipe -Wextra -Werror" \
%else
make CFLAGS="$RPM_OPT_FLAGS -fpie -pipe -Wextra -Werror" \
%endif
        LINK="-pie -lssl" %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/{vsftpd,pam.d,logrotate.d,rc.d/init.d}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man{5,8}
install -m 755 vsftpd  $RPM_BUILD_ROOT%{_sbindir}/vsftpd
install -m 600 vsftpd.conf $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd.conf
install -m 644 vsftpd.conf.5 $RPM_BUILD_ROOT/%{_mandir}/man5/
install -m 644 vsftpd.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
install -m 644 RedHat/vsftpd.log $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/vsftpd
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/vsftpd
install -m 600 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/ftpusers
install -m 600 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/user_list
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/vsftpd
install -m 744 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd_conf_migrate.sh
# Ext.1
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-403.html
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-404.html
install -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-browse.html
install -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-browse_line.html
install -m 644 %{SOURCE11} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-403-serv.html
install -m 644 %{SOURCE12} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd-site.conf.sample
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT%{_sysconfdir}/vsftpd/vsftpd.pasv_rules

mkdir -p $RPM_BUILD_ROOT/%{_var}/ftp/pub


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/chkconfig --add vsftpd


%preun
if [ $1 = 0 ]; then
 /sbin/service vsftpd stop > /dev/null 2>&1
 /sbin/chkconfig --del vsftpd
fi


%files
%defattr(-,root,root,-)
%{_sbindir}/vsftpd
%{_sysconfdir}/rc.d/init.d/vsftpd
%dir %{_sysconfdir}/vsftpd
%{_sysconfdir}/vsftpd/vsftpd_conf_migrate.sh
%config(noreplace) %{_sysconfdir}/vsftpd/ftpusers
%config(noreplace) %{_sysconfdir}/vsftpd/user_list
%config(noreplace) %{_sysconfdir}/vsftpd/vsftpd.conf
%config(noreplace) %{_sysconfdir}/pam.d/vsftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/vsftpd
%config(noreplace) %{_sysconfdir}/vsftpd/vsftpd-site.conf.sample
%config(noreplace) %{_sysconfdir}/vsftpd/vsftpd-*.html
%config(noreplace) %{_sysconfdir}/vsftpd/vsftpd.pasv_rules
%doc FAQ INSTALL BUGS AUDIT Changelog LICENSE README README.security REWARD
%doc SPEED TODO BENCHMARKS COPYING SECURITY/ EXAMPLE/ TUNING SIZE vsftpd.xinetd
%{_mandir}/man5/vsftpd.conf.*
%{_mandir}/man8/vsftpd.*
%{_var}/ftp


%changelog
* Thu Feb 23 2012 Frolov Denis <d.frolov81@mail.ru> - 2.3.5-2
- Add ssl_userlist patch

* Thu Jan 03 2012 Frolov Denis <d.frolov81@mail.ru> - 2.3.5-1
- Update to 2.3.5-ext1

* Wed Nov 16 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-6
- Update to 2.3.4-ext2

* Sun May 01 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-5
- add pam_service_name=vsftpd in vsftpd.conf

* Sun Mar 20 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-4
- add ssl patch

* Thu Mar 17 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-3
- add ipv6_port_pasv and sanity_check patch

* Thu Feb 25 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-2
- Update to 2.3.4-ext1 final

* Thu Feb 16 2011 Frolov Denis <d.frolov81@mail.ru> - 2.3.4-1
- Update to 2.3.4-ext1

* Sat Aug 21 2010 Frolov Denis <d.frolov81@mail.ru> - 2.3.2-1
- Update to 2.3.2-ext1

* Sat Aug 14 2010 Frolov Denis <d.frolov81@mail.ru> - 2.3.0-1
- Update to 2.3.0-ext1

* Thu Apr 06 2010 Frolov Denis <d.frolov81@mail.ru> - 2.2.2-2
- Update to 2.2.2-ext1 patch

* Mon Jan 04 2010 Frolov Denis <d.frolov81@mail.ru> - 2.2.2-1
- Update to 2.2.2-1

* Mon Jul 06 2009 Frolov Denis <d.frolov81@mail.ru> - 2.1.2-1
- Update to 2.1.2

* Wed Apr 07 2009 Frolov Denis <d.frolov81@mail.ru> - 2.1.0-2
- Rebuild with http://vsftpd.devnet.ru/
